// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from septentrio_gnss_driver:msg/PVTCartesian.idl
// generated code does not contain a copyright notice

#ifndef SEPTENTRIO_GNSS_DRIVER__MSG__DETAIL__PVT_CARTESIAN__TRAITS_HPP_
#define SEPTENTRIO_GNSS_DRIVER__MSG__DETAIL__PVT_CARTESIAN__TRAITS_HPP_

#include "septentrio_gnss_driver/msg/detail/pvt_cartesian__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'block_header'
#include "septentrio_gnss_driver/msg/detail/block_header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const septentrio_gnss_driver::msg::PVTCartesian & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: block_header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "block_header:\n";
    to_yaml(msg.block_header, out, indentation + 2);
  }

  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    value_to_yaml(msg.mode, out);
    out << "\n";
  }

  // member: error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "error: ";
    value_to_yaml(msg.error, out);
    out << "\n";
  }

  // member: x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x: ";
    value_to_yaml(msg.x, out);
    out << "\n";
  }

  // member: y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y: ";
    value_to_yaml(msg.y, out);
    out << "\n";
  }

  // member: z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z: ";
    value_to_yaml(msg.z, out);
    out << "\n";
  }

  // member: undulation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "undulation: ";
    value_to_yaml(msg.undulation, out);
    out << "\n";
  }

  // member: vx
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vx: ";
    value_to_yaml(msg.vx, out);
    out << "\n";
  }

  // member: vy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vy: ";
    value_to_yaml(msg.vy, out);
    out << "\n";
  }

  // member: vz
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vz: ";
    value_to_yaml(msg.vz, out);
    out << "\n";
  }

  // member: cog
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cog: ";
    value_to_yaml(msg.cog, out);
    out << "\n";
  }

  // member: rx_clk_bias
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rx_clk_bias: ";
    value_to_yaml(msg.rx_clk_bias, out);
    out << "\n";
  }

  // member: rx_clk_drift
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rx_clk_drift: ";
    value_to_yaml(msg.rx_clk_drift, out);
    out << "\n";
  }

  // member: time_system
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_system: ";
    value_to_yaml(msg.time_system, out);
    out << "\n";
  }

  // member: datum
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "datum: ";
    value_to_yaml(msg.datum, out);
    out << "\n";
  }

  // member: nr_sv
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nr_sv: ";
    value_to_yaml(msg.nr_sv, out);
    out << "\n";
  }

  // member: wa_corr_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wa_corr_info: ";
    value_to_yaml(msg.wa_corr_info, out);
    out << "\n";
  }

  // member: reference_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_id: ";
    value_to_yaml(msg.reference_id, out);
    out << "\n";
  }

  // member: mean_corr_age
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mean_corr_age: ";
    value_to_yaml(msg.mean_corr_age, out);
    out << "\n";
  }

  // member: signal_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "signal_info: ";
    value_to_yaml(msg.signal_info, out);
    out << "\n";
  }

  // member: alert_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "alert_flag: ";
    value_to_yaml(msg.alert_flag, out);
    out << "\n";
  }

  // member: nr_bases
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nr_bases: ";
    value_to_yaml(msg.nr_bases, out);
    out << "\n";
  }

  // member: ppp_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ppp_info: ";
    value_to_yaml(msg.ppp_info, out);
    out << "\n";
  }

  // member: latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "latency: ";
    value_to_yaml(msg.latency, out);
    out << "\n";
  }

  // member: h_accuracy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "h_accuracy: ";
    value_to_yaml(msg.h_accuracy, out);
    out << "\n";
  }

  // member: v_accuracy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "v_accuracy: ";
    value_to_yaml(msg.v_accuracy, out);
    out << "\n";
  }

  // member: misc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "misc: ";
    value_to_yaml(msg.misc, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const septentrio_gnss_driver::msg::PVTCartesian & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<septentrio_gnss_driver::msg::PVTCartesian>()
{
  return "septentrio_gnss_driver::msg::PVTCartesian";
}

template<>
inline const char * name<septentrio_gnss_driver::msg::PVTCartesian>()
{
  return "septentrio_gnss_driver/msg/PVTCartesian";
}

template<>
struct has_fixed_size<septentrio_gnss_driver::msg::PVTCartesian>
  : std::integral_constant<bool, has_fixed_size<septentrio_gnss_driver::msg::BlockHeader>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<septentrio_gnss_driver::msg::PVTCartesian>
  : std::integral_constant<bool, has_bounded_size<septentrio_gnss_driver::msg::BlockHeader>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<septentrio_gnss_driver::msg::PVTCartesian>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SEPTENTRIO_GNSS_DRIVER__MSG__DETAIL__PVT_CARTESIAN__TRAITS_HPP_
